/********************************************************************
	
	message.h - defined messages

  Niksa Orlic, 2004-04-19

********************************************************************/

/* General messages */
#define MSG_001		"Out of memory"
#define MSG_002		"Too many errors"
#define MSG_003		"Cannot create record file"
#define MSG_004		"Cannot create class file"
#define MSG_005		"Cannot open source file"
#define MSG_006		"Serious error occured, stopping compilation"
#define MSG_007		"Cannot create binary symbol file"

#define MSG_010		"Internal error #010"
#define MSG_011		"Internal error #011"
#define MSG_012		"Internal error #012"
#define MSG_013     "Internal error #013"
#define MSG_014		"Internal error #014"
#define MSG_015		"Internal error #015"
#define MSG_016		"Internal error #016"
#define MSG_017		"Internal error #017"
#define MSG_018		"Internal error #018"
#define MSG_019		"Internal error #019"
#define MSG_020		"Internal error #020"
#define MSG_021		"Internal error #021"
#define MSG_022		"Internal error #022"
#define MSG_023		"Internal error #023"
#define MSG_024		"Internal error #024"
#define MSG_025		"Internal error #025"
#define MSG_026		"Internal error #026"


/* Scanner errors */
#define MSG_100		"unknown character \'%s\', ignored"
#define MSG_101		"newline in string constant"
#define MSG_102		"error in preprocessor statement"

/* Parser errors */
#define MSG_200		"character \'%s\' expected, \'%s\' found"
#define MSG_201		"unexpected text \'%s\' after program end"
#define MSG_202		"identifier (name) expected"
#define MSG_203		"keyword \'%s\' expected, \'%s\' found"
#define MSG_204		"unexpected token \'%s\'"
#define MSG_205		"operator \'=\' expected, \'%s\' found"
#define MSG_206		"constant expected"
#define MSG_207		"unexpected end of file found"
#define MSG_208		"error in parameter list on token \'%s\'"
#define MSG_209		"operator \':=\' expected, \'%s\' found"
#define MSG_210		"\'packed\' arrays not supported; ordinary array will be used"
#define MSG_211		"sets are not supported in this version"
#define MSG_212		"enumerated types are not supported in this version"
#define MSG_213		"operator \'..\' expected, \'%s\' found"
#define MSG_214		"keyword \'end\' expected, \'%s\' found"
#define MSG_215		"\'with\' is not supported in this version"
#define MSG_216		"keyword \'then\' expected, \'%s\' found"
#define MSG_217		"constant of type integer or char expected"
#define MSG_218		"operator \':=\' expected"
#define MSG_219		"\'break\' statemnt found outside of do-while, repeat-until or for loop"
#define MSG_220		"compiler does ot support the \'finalization\' part of the unit"
#define MSG_221		"procedures and functions may not contain body inside unit interface part"


/* Semantic errors */
#define MSG_400		"identifier \'%s\' already defined"
#define MSG_401		"method was already declared as forward"
#define MSG_402		"a %s with the same name was declared as forward"
#define MSG_403		"parameter list is shorter than the list in previous forward declaration"
#define MSG_404		"parameter list differs on element %s from the list in previous forward declaration"
#define MSG_405		"return type is different than the return type declared in the previous forward declaration"
#define MSG_406		"unknown type \'%s\'"
#define MSG_407		"%s type expected"
#define MSG_408		"integer, char or string type expected"
#define MSG_409		"constant of type %s expected, %s found"
#define MSG_410		"\'%s\' is not a constant"
#define MSG_411		"integer or char type expected"
#define MSG_412		"%s type expected, %s type found"
#define MSG_413		"wrong type in interval definition"
#define MSG_414		"\'%s\' is not a constant"
#define MSG_415		"type name or integer/char constant expected, \'%s\' found"
#define MSG_416		"error in interval definition"
#define MSG_417		"operand is wrong type"
#define MSG_418		"name \'%s\' already exists in a record declaration"
#define MSG_419		"procedure/function takes 0 arguments, brackets must be left out"
#define MSG_420		"procedure/function takes more than 0 arguments, '(' expected"
#define MSG_421		"parameter list is too short"
#define MSG_422		"error on parameter %s"
#define MSG_423		"left and right operands to \':=\' must have the same type"
#define MSG_424		"\'.\' operator can only be used on record types"
#define MSG_425		"the record does not contain element named \'%s\'"
#define MSG_426		"\'[\' operator can only be used on array types"
#define MSG_427		"error in array dimensions (array has %s dimensions, %s are specified)"
#define MSG_428		"identifier \'%s\' is not procedure, function, variable or unit name"
#define MSG_429		"identifier \'%s\' is not constant, function or variable name"
#define MSG_430		"only interval types can be used for array indexes"
#define MSG_431		"nested functions or procedures are not supported"
#define MSG_432		"function \'%s\' cannot be called from here; procedure call or assignement expected"
#define MSG_433		"\'run\' is reserved name and cannot be used as a function or procedure name"
#define MSG_434		"only string, character, integer or boolean can be appended to string"
#define MSG_435		"files are not supported in this version"
#define MSG_436		"variable parameters are not supported and will be ignored"
#define MSG_437		"invalid interval"
#define MSG_438		"interval too large"
#define MSG_439		"only integer type can be used as string index"
#define MSG_440		"variables of interval type are not supported"
#define MSG_441		"only forward declaration supplied; the implementation is missing"
#define MSG_442		"case statement is not supported in this version"
#define MSG_443		"a value cannot be asigned to array. This will be fixed in future versions of MIDletPascal"
#define MSG_444		"unknown identifier"
#define MSG_445		"name of the procedure/function has already been taken by another identifier"
#define MSG_446		"arrays in records (\'%s\') are not yet implemented"
#define MSG_447		"unknown record element \'%s\'"
#define MSG_448		"failed to load \'%s\' library/unit"
#define MSG_449		"error reading external library file"
#define MSG_450		"could not load library/unit \'%s\' because identifier of the same name already exists"
#define MSG_451		"serious internal error in library"
#define MSG_452		"library/unit contains a method with an incorrect argument type"
#define MSG_453		"library/unit does not contain function \'%s\'"
#define MSG_454		"unit name must contain at least 2 characters"
#define MSG_455		"library/unit does not contain type \'%s\'"
#define MSG_456		"iterator used in for-loop must not be defined inside a library/unit"
#define MSG_457		"identifier \'%s\' is not a procedure or variable name"
#define MSG_458		"identifier \'%s\' is not a function, variable or constant name"
#define MSG_459		"identifier \'%s\' found in more units; use syntax 'unit_name'.'identifier' to resolve ambiguity"